//
//  Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
//  Copyright (C) 2013 - Pawel Zagorski
//
//  This file must be used under the terms of the CeCILL.
//  This source file is licensed as described in the file COPYING, which
//  you should have received as part of this distribution.  The terms
//  are also available at
//  http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt


function block=AB_fr_convert(block,flag)

previousprot = funcprot(0)

block_name = "AB_fr_convert";
xcos_block_debug(block, flag, block_name);

select flag
  case 1 then
    // Output computation
    pos_IN = block.inptr(1);
    vel_IN = block.inptr(2);
    cjd     = block.inptr(3);
    jacobian = block.opar(1);
    frame_IN = block.opar(2);
    frame_OUT = block.opar(3);
    pcor = block.opar(4);
    cipcor = block.opar(5);
    ut1_tref = block.rpar(1);
    tt_tref = block.rpar(2);
    if(jacobian)
	[pos_OUT,vel_OUT, jacob] = CL_fr_convert(frame_IN, frame_OUT, cjd, pos_IN, vel_IN, ut1_tref, tt_tref, pcor(1), pcor(2), cipcor(1), cipcor(2));
	block.outptr(1) = jacob;
    else
	[pos_OUT,vel_OUT] = CL_fr_convert(frame_IN, frame_OUT, cjd, pos_IN, vel_IN, ut1_tref, tt_tref, pcor(1), pcor(2), cipcor(1), cipcor(2));
	block.outptr(1) = pos_OUT;
	block.outptr(2) = vel_OUT; 
    end
  case 4 then
    // Initialization
    AB_check_param_number(block_name, block, 0, 1, 4);
  case 5 then
    // Ending
    ;
  case 6 then
    // Initialization, fixed-point computation
    ;
  else
    error(msprintf(gettext("%s : Incorect flag %d"), block_name, flag));
end

funcprot(previousprot)
endfunction
