// This file is released under the 3-clause BSD license. See COPYING-BSD.
//=================================

// Test data is generated by sciab command: 
//-->inv(q)
// ans  =
// 
// 
//    0.0189296  
//  - 0.0395801  
//  - 0.0774393  
//  - 0.0963690  


// Test flags
//<-- XCOS TEST -->
//<-- NO CHECK ERROR OUTPUT -->

//Load xcos test diagram for quat_invert tests
[macros,path] = libraryinfo('xcos_aerolib');
result = importXcosDiagram(path + "../tests/unit_tests" + "/quat_invert.zcos");
assert_checktrue(result);

//This diagram uses 5 variables : 
//  r_in - real quaternion part
//  i_in -
//  j_in -  imaginary quaternion parts
//  k_in -
//  quat_out - resulting quaternion

r_in = 1.1;
i_in = 2.3;
j_in = 4.5;
k_in = 5.6;

scicos_simulate(scs_m);

// Define expected values
time_expected = [0.1; 1.1; 2.1];
quat_expected = [ 0.0189296, -0.0395801, -0.0774393, -0.0963690;
                  0.0189296, -0.0395801, -0.0774393, -0.0963690;
                  0.0189296, -0.0395801, -0.0774393, -0.0963690]

//Validate results
assert_checkequal(quat_out.time, time_expected);
assert_checkalmostequal(quat_out.values, quat_expected, 1e-6);
