// This file is released under the 3-clause BSD license. See COPYING-BSD.
//=================================

// Test data is generated by sciab command: 
// sqrt(1.1^2 + 2.3^2 + 4.5^2 +5.6^2)
// ans  =
// 
//    7.6229915 

// Test flags
//<-- XCOS TEST -->
//<-- NO CHECK ERROR OUTPUT -->

//Load xcos test diagram for quat_norm tests
[macros,path] = libraryinfo('xcos_aerolib');
result = importXcosDiagram(path + "../tests/unit_tests" + "/quat_norm.zcos");
assert_checktrue(result);

//This diagram uses 5 variables : 
//  r_in - real quaternion part
//  i_in -
//  j_in -  imaginary quaternion parts
//  k_in -
//  norm_out - quaternion norm calculated from the diagram

r_in = 1.1;
i_in = 2.3;
j_in = 4.5;
k_in = 5.6;

scicos_simulate(scs_m);

// Define expected values
time_expected = [0.1; 1.1; 2.1];
norm_expected = [7.6229915; 7.6229915; 7.6229915];

//Validate results
assert_checkequal(norm_out.time, time_expected);
assert_checkalmostequal(norm_out.values, norm_expected, 1e-3);
