// This file is released under the 3-clause BSD license. See COPYING-BSD.
//=================================


// Test flags
//<-- XCOS TEST -->
//<-- NO CHECK ERROR OUTPUT -->

//Load xcos test diagram for vector_normalization tests
[macros,path] = libraryinfo('xcos_aerolib');
result = importXcosDiagram(path + "../tests/unit_tests" +"/vector_norm.zcos");
assert_checktrue(result);

//This diagram uses 2 variables : 
//  vectors_in : input vectors (from_workspace)
//  norms_out : output norms (to_workspace)

vectors_in = [	0,	 1,	-1,	 0.1;
		0,	-1,	 1,	 0.2;
		0.123,	 1,	 0,	 0.3];

scicos_simulate(scs_m);

// Define expected values
exp_time = [0; 1; 2];
exp_value = [	0.123,	1.73205080756887719, 1.4142135623730951, 0.37416573867739417]; 

//Validate results
assert_checkequal(norms_out.time, exp_time);
assert_checkalmostequal(norms_out.values(:,:,1), exp_value, 1e-7);
assert_checkalmostequal(norms_out.values(:,:,2), exp_value, 1e-7);
assert_checkalmostequal(norms_out.values(:,:,3), exp_value, 1e-7);

