// This file is released under the 3-clause BSD license. See COPYING-BSD.
//=================================

// Test data is generated by calculating x vector rotation around z axis (should be equal to y axis)
// quat_in = CL_rot_axAng2quat([0;0;1], %pi/2);
// 

// Test flags
//<-- XCOS TEST -->
//<-- NO CHECK ERROR OUTPUT -->

//Load xcos test diagram for quat_rotate tests
[macros,path] = libraryinfo('xcos_aerolib');
result = importXcosDiagram(path + "../tests/unit_tests" + "/vector_rotate.zcos");
assert_checktrue(result);

//This diagram uses 3 variables : 
//  quat_in - input quaternion [1x4] vector
//  vec_in  - input vector [1x3] vector
//  vec_out - output vector [3x1] vector

quat_in = [0.7071068; 0. ; 0. ;  0.7071068]                 //already normalized
vec_in = [1; 0; 0];

scicos_simulate(scs_m);

// Define expected values
time_expected = [0.1; 1.1; 2.1];
vec_expected(1,:) = [0, 1, 0];
vec_expected(2,:) = [0, 1, 0];
vec_expected(3,:) = [0, 1, 0];


//Validate results
assert_checkequal(vec_out.time, time_expected);
assert_checkalmostequal(vec_out.values, vec_expected, 1e-3);
